curl --request PATCH \
--url https://api.hellotracks.com/v1/timesheets/entries/{id} \
--header 'API-Key: <api-key>' \
--header 'Content-Type: application/json' \
--data '
{
"clockOut": "15:30"
}
'import requests
url = "https://api.hellotracks.com/v1/timesheets/entries/{id}"
payload = { "clockOut": "15:30" }
headers = {
"API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.patch(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PATCH',
headers: {'API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({clockOut: '15:30'})
};
fetch('https://api.hellotracks.com/v1/timesheets/entries/{id}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.hellotracks.com/v1/timesheets/entries/{id}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PATCH",
CURLOPT_POSTFIELDS => json_encode([
'clockOut' => '15:30'
]),
CURLOPT_HTTPHEADER => [
"API-Key: <api-key>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.hellotracks.com/v1/timesheets/entries/{id}"
payload := strings.NewReader("{\n \"clockOut\": \"15:30\"\n}")
req, _ := http.NewRequest("PATCH", url, payload)
req.Header.Add("API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.patch("https://api.hellotracks.com/v1/timesheets/entries/{id}")
.header("API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"clockOut\": \"15:30\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.hellotracks.com/v1/timesheets/entries/{id}")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Patch.new(url)
request["API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"clockOut\": \"15:30\"\n}"
response = http.request(request)
puts response.read_body{
"data": {
"entry": {
"id": "650000000000000000000011_650000000000000000000012",
"member": {
"id": "a1b2c3",
"name": "Driver 1",
"username": "driver1@example.com",
"email": "driver1@example.com"
},
"date": "2026-10-30",
"clockIn": {
"id": "650000000000000000000011",
"timestamp": 1761832800000,
"time": "07:00",
"type": 1,
"isClockIn": true
},
"clockOut": {
"id": "650000000000000000000012",
"timestamp": 1761863400000,
"time": "15:30",
"type": -1,
"isClockIn": false
},
"durationSeconds": 30600,
"open": false
}
},
"error": null,
"meta": {
"path": "/v1/timesheets/entries/650000000000000000000011_650000000000000000000012",
"method": "PATCH"
}
}{
"data": null,
"error": {
"code": "invalid_request",
"message": "date must be YYYY-MM-DD"
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "invalid_api_key",
"message": "Invalid Hellotracks API key."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "forbidden",
"message": "No permission."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "throttled",
"message": "Too many requests."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "internal_error",
"message": "Hellotracks API is temporarily unavailable."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}Change a timesheet entry
Moves the clock-in and/or clock-out of an entry, or adds the missing clock-out. At least one time field is required. The answer’s entry may have a new id. An unknown or foreign entry is answered with 400 invalid_request. Admins, operators and the company key may call it; workers get 403.
curl --request PATCH \
--url https://api.hellotracks.com/v1/timesheets/entries/{id} \
--header 'API-Key: <api-key>' \
--header 'Content-Type: application/json' \
--data '
{
"clockOut": "15:30"
}
'import requests
url = "https://api.hellotracks.com/v1/timesheets/entries/{id}"
payload = { "clockOut": "15:30" }
headers = {
"API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.patch(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PATCH',
headers: {'API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({clockOut: '15:30'})
};
fetch('https://api.hellotracks.com/v1/timesheets/entries/{id}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.hellotracks.com/v1/timesheets/entries/{id}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PATCH",
CURLOPT_POSTFIELDS => json_encode([
'clockOut' => '15:30'
]),
CURLOPT_HTTPHEADER => [
"API-Key: <api-key>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.hellotracks.com/v1/timesheets/entries/{id}"
payload := strings.NewReader("{\n \"clockOut\": \"15:30\"\n}")
req, _ := http.NewRequest("PATCH", url, payload)
req.Header.Add("API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.patch("https://api.hellotracks.com/v1/timesheets/entries/{id}")
.header("API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"clockOut\": \"15:30\"\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.hellotracks.com/v1/timesheets/entries/{id}")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Patch.new(url)
request["API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"clockOut\": \"15:30\"\n}"
response = http.request(request)
puts response.read_body{
"data": {
"entry": {
"id": "650000000000000000000011_650000000000000000000012",
"member": {
"id": "a1b2c3",
"name": "Driver 1",
"username": "driver1@example.com",
"email": "driver1@example.com"
},
"date": "2026-10-30",
"clockIn": {
"id": "650000000000000000000011",
"timestamp": 1761832800000,
"time": "07:00",
"type": 1,
"isClockIn": true
},
"clockOut": {
"id": "650000000000000000000012",
"timestamp": 1761863400000,
"time": "15:30",
"type": -1,
"isClockIn": false
},
"durationSeconds": 30600,
"open": false
}
},
"error": null,
"meta": {
"path": "/v1/timesheets/entries/650000000000000000000011_650000000000000000000012",
"method": "PATCH"
}
}{
"data": null,
"error": {
"code": "invalid_request",
"message": "date must be YYYY-MM-DD"
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "invalid_api_key",
"message": "Invalid Hellotracks API key."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "forbidden",
"message": "No permission."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "throttled",
"message": "Too many requests."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "internal_error",
"message": "Hellotracks API is temporarily unavailable."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}Authorizations
Your API key, from More → API & Integrations in the dashboard, or from ht signup / ht auth login.
Path Parameters
Entry id clockInId_clockOutId, as listed ("-" for a missing side).
Body
Times either as HH:mm on a day (date, and clockOutDate when the clock-out is on another day) or as ms timestamps (clockInAt, clockOutAt). Use clockIn or clockInAt, not both; the same for clockOut. Times are read in the caller's time zone.
Create only, required: a member of the company.
YYYY-MM-DD; required on create when clockIn or clockOut is used. On update it defaults to the entry's day.
YYYY-MM-DD of the clock-out; defaults to date.
HH:mm (00:00 to 24:00).
^\d{2}:\d{2}$HH:mm (00:00 to 24:00).
^\d{2}:\d{2}$Milliseconds since the epoch (a numeric string works too).
Milliseconds since the epoch.